package uk.ac.umist.co.brailletrans.tests;
import uk.ac.umist.co.brailletrans.*;
import uk.ac.umist.co.brailletrans.utils.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class OutputTestAll extends Translator
{
  static final String RESULT_SUFFIX = ".out.txt";

  public static void main(String[] args) throws Exception
  {
    String inFilename = "";
    String languageToUse = "";
    Language256 language256 = null;
    LanguageUnicode languageUnicode = null;
    LanguageInteger languageInteger = null;
    TranslateC languageC = null;
    String result256 = null;
    String resultInteger = null;
    String resultUnicode = null;
    String resultC = null;
    byte[] cOutput = null;


    int state = 1;

    if (args.length != 3)
    {
      System.out.println("OutputTest");
      System.out.println("USAGE  java OutputTest <file> <language> <state>");
      System.exit(SUCCESS);
    }

    inFilename = new String(args[0]);
    languageToUse = new String(args[1]);
    state = Integer.parseInt(args[2]);
    args = null;

//    try
//    {
      language256 = new Language256(languageToUse);
      language256.setState(state);
      languageUnicode = new LanguageUnicode(languageToUse);
      languageUnicode.setState(state);
      languageInteger = new LanguageInteger(languageToUse);
      languageInteger.setState(state);
      languageC = new TranslateC();
      languageC.InitBrl(languageToUse + Language256.FILENAME_EXTENSION);
      languageC.SetState((byte) state);

    // Get the input to translate

      result256 = turnIntoString(language256.translate(readIntArrayFromDisk(inFilename)));
      resultInteger = turnIntoString(languageInteger.translate(readIntArrayFromDisk(inFilename)));
      resultUnicode = languageUnicode.translate(readStringFromDisk(inFilename));
      cOutput = new byte[result256.length()];
      languageC.Translate(Translator.turnIntoByteArray(readIntArrayFromDisk(inFilename)),
        cOutput);
      resultC = Translator.turnIntoString(cOutput);

//    }
//    catch (Exception e)
//    {
//      System.err.println("Error: " + e);
//    }


    String toDisplay = new String
    ("Translation Results" + "\n" + "Language256"  + "\n" + result256
      + "\n\n" + "LanguageInteger" + "\n" + resultInteger  + "\n\n" +
      "LanguageUnicode" + "\n" + resultUnicode + "\n\n" + "LanguageC"
      + "\n" + resultC);

    JTextArea display = new JTextArea(toDisplay, 20, 50);
    JOptionPane.showMessageDialog(null, new JScrollPane(display), "Translation Output",
      JOptionPane.NO_OPTION);

    System.exit(SUCCESS);




  }
}
