package uk.ac.umist.co.brailletrans.tests;
import java.math.*;

public class Stopwatch
{
  private long startTime;
  private long stopTime;
  private long timedResult;
  private long cumulativeTime;
  public String id;
  private int numberTimes;
  private int numberToTime;
  private long[] results;
  private long standardDeviation;

  public Stopwatch()
  {
    startTime = 0;
    stopTime = 0;
    cumulativeTime = 0;
    timedResult = 0;
    numberTimes = 0;
    numberToTime = 0;
    standardDeviation = 0;
  }

  public Stopwatch(int numberToTime)
  {
    this();
    this.numberToTime = numberToTime;
    results = new long[numberToTime];
  }

  public final void start()
  {
    startTime = System.currentTimeMillis();
  }

  public final void stop()
  {
    stopTime = System.currentTimeMillis();
    timedResult = stopTime - startTime;
    cumulativeTime += timedResult;
    if ((numberToTime != 0) && (numberTimes < numberToTime))
      results[numberTimes] = timedResult;
    numberTimes++;
    if (numberTimes == numberToTime)
      calculateSD();
  }

  public final void reset()
  {
    timedResult = 0;
    cumulativeTime = 0;
    numberTimes = 0;
    standardDeviation = 0;
  }

  public long getTime()
  {
    return timedResult;
  }

  public long getTotal()
  {
    return cumulativeTime;
  }

  public long meanTime()
  {
    if (numberTimes == 0)
      return 0;
    return cumulativeTime / numberTimes;
  }

  public long[] getResults()
  {
    return results;
  }

  public long sdTime()
  {
    return standardDeviation;
  }

  private void calculateSD()
  {
    long total = 0;
    for (int i = 0; i < numberToTime; i++)
      total += ((results[i] - meanTime()) * (results[i] - meanTime()));
    total /= numberToTime;
    standardDeviation = (long) Math.sqrt(total);
  }
}
